#####################################################################
#
#       Author : Kushal Das
#       Copyright (c)  2007-2009 Kushal Das
#       kushal@fedoraproject.org
#
#####################################################################


import sys
import os
import codecs
from poparser import *

class BasicTranslation:
    """Base class"""
    def __init__(self, path=os.path.join(os.path.expanduser("~"), ".translation-filter")):
        self.filename = ""
        self.path = path
        self.html = ""
        self.text = ''

    def exit(self):
        sys.exit(0)

    def wrongspellings(self, lang):
        """To search wrong spellings , Indic specific"""
        #if lang not in ['mr','hi','bn','hi','ta','te','kn','or','gu','pa']:
        #    print "Wrong Locale"
        #    sys.exit(1)
        #if lang == "as":
        #    lang = 'bn'
        #elif lang == 'mr' or lang == "hi":
        #    lang = "dev"
        lang = "all"
        if os.path.isfile(self.path):
            files = [x.strip() for x in open(self.path).readlines()]
            if len(files) > 0:
                results = findwrongspellings(files,lang)
            else:
                results = findwrongspellings(getpofile("."), lang)
        else:
            results = findwrongspellings(getpofile(self.path), lang)
        html = ""
        for res in results:
            html +="<tr>"
            html += """<td><a href=\"""" + res[0] +"""\">""" + res[0] + """</a></td>"""
            html += "<td>"
            print "Unattached vowel signs found in the following lines:"
            for val in res[1]:
                number = findline(res[0],val.msgstr[0])
                html += """msgid: """ + val.msgid[0] + """"""
                html += """<div id="end">msgstr: """ + val.msgstr[0] + """</div>"""
                print "%s:%d" % (res[0],number)
            html += "</td></tr>"
        self.html = html

    def search(self, text):
        """To search any particular string"""
        if os.path.isfile(self.path):
            files = [x.strip() for x in open(self.path).readlines()]
            if len(files) > 0:
                results = findtext(files,text)
            else:
                results = findtext(getpofile("."), text)
        else:
            results = findtext(getpofile(self.path), text)
        html = ""
        txt = ''
        for res in results:
            html +="<tr>"
            html += """<td><a href=\"""" + res[0] +"""\">""" + res[0] + """</a></td>"""
            html += "<td>"
            txt +="\n" + res[0] + '\n\n'
            for val in res[1]:
                html += """msgid: """ + val.msgid[0] + """"""
                html += """<div id="end">msgstr: """ + val.msgstr[0] + """</div>"""
                txt += 'msgid: ' + val.msgid[0] + '\n'
                txt += 'msgstr: ' + val.msgstr[0] + '\n'
            html += "</td></tr>"
        self.html = html
        self.text = txt

    def fileSave(self):
        if self.filename == '':
            return False
        data = codecs.open("/usr/share/translationfilter/data/index.html", encoding="UTF-8").read()
        data = data.replace("%<<Replace>>", self.html)
        f = codecs.open(self.filename,'w', encoding="UTF-8")
        f.write(data)
        f.close()
        return True

    def createwordlist(self):
        """
        Create a wordlist
        """
        files = getpofile(self.path)
        results = []
        for f in files:
            results.extend(findsingleword(f))

        f = codecs.open('words.list','w', encoding="UTF-8")
        #Now save the results in word.list
        #output = [(res.msgid[0].strip('"'),res.msgstr[0]) for res in results if res.msgid[0] != u'""']
        output = []
        for res in results:
            if res.msgid[0] != u'""':
                if (res.msgid[0], res.msgstr[0]) not in output:
                    output.append((res.msgid[0], res.msgstr[0]))

        #Sort the final result
        output.sort()

        for res in output:
            f.write('%s %s\n'% res)

        f.close()


